import { BrowserModule } from '@angular/platform-browser';
import { Injectable, Component, EventEmitter, Output, Input, NgModule, defineInjectable } from '@angular/core';
import { FormsModule } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OmnipresentWebLibService {
    constructor() { }
}
OmnipresentWebLibService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
OmnipresentWebLibService.ctorParameters = () => [];
/** @nocollapse */ OmnipresentWebLibService.ngInjectableDef = defineInjectable({ factory: function OmnipresentWebLibService_Factory() { return new OmnipresentWebLibService(); }, token: OmnipresentWebLibService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OmnipresentWebLibComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
OmnipresentWebLibComponent.decorators = [
    { type: Component, args: [{
                selector: 'omnipresent-web-omnipresent-web-lib',
                template: `
    <p>
      omnipresent-web-lib works!
    </p>
  `
            }] }
];
/** @nocollapse */
OmnipresentWebLibComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class User {
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class LoginComponent {
    constructor() {
        this.emailPassword = true;
        this.google = true;
        this.twitter = true;
        this.googleEventEmitter = new EventEmitter();
        this.twitterEventEmitter = new EventEmitter();
        this.emailEventEmitter = new EventEmitter();
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.user = new User();
    }
    /**
     * @return {?}
     */
    loginWithGoogle() {
        this.googleEventEmitter.emit(true);
    }
    /**
     * @return {?}
     */
    loginWithTwitter() {
        this.twitterEventEmitter.emit(true);
    }
    /**
     * @return {?}
     */
    loginWithEmail() {
        this.emailEventEmitter.emit(this.user);
    }
}
LoginComponent.decorators = [
    { type: Component, args: [{
                selector: 'omnipresent-web-login',
                template: "<div class=\"login\">\n    <div class=\"email-password\" *ngIf=\"emailPassword\">\n        <input [(ngModel)]=\"user.email\" type=\"text\" placeholder=\"Email\" #userEmail required autofocus>\n        <input [(ngModel)]=\"user.password\" type=\"password\" placeholder=\"Password\" #userPassword required>\n        <button (click)=\"loginWithEmail()\">Login</button>\n        <div class=\"divider\">\n            <div class=\"bar\"></div>\n            <span class=\"login-or\">OR</span>\n            <div class=\"bar\"></div>\n        </div>\n    </div>\n    <button *ngIf=\"twitter\" class=\"register-button twitter\" (click)=\"loginWithTwitter()\">\n      <i class=\"fab fa-twitter\"></i>\n      <span>Login with Twitter</span>\n    </button>\n    <button *ngIf=\"google\" class=\"register-button google\" (click)=\"loginWithGoogle()\">\n      <i class=\"fab fa-google\"></i>\n      <span>Login with Google</span>\n    </button>\n</div>\n",
                styles: [".login{text-align:center;display:-ms-grid;display:grid;margin:auto;max-width:400px}.twitter{background-color:#60b5f0}.google{background-color:#db3236}i{margin-right:10px}.divider{display:flex;justify-content:center;margin:20px}.divider .bar{border-bottom:2px solid #2c3e50;margin:5px;width:35%}.email-password{text-align:center;display:-ms-grid;display:grid;margin:auto;width:100%}"]
            }] }
];
/** @nocollapse */
LoginComponent.ctorParameters = () => [];
LoginComponent.propDecorators = {
    emailPassword: [{ type: Input }],
    google: [{ type: Input }],
    twitter: [{ type: Input }],
    googleEventEmitter: [{ type: Output }],
    twitterEventEmitter: [{ type: Output }],
    emailEventEmitter: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class ViewImageComponent {
    constructor() {
        this.weekIms = [];
        this.counter1 = 0;
        this.show = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.picterno = 0;
    }
    /**
     * @return {?}
     */
    ngDoCheck() {
        if (this.data) {
            this.counter1++;
            if (this.counter1 == 1) {
                this.assignImages();
            }
        }
        else {
            this.images = [];
        }
    }
    /**
     * @return {?}
     */
    OnRight() {
        if (this.picterno + 8 < this.data.length) {
            this.picterno += 8;
            this.assignImages();
        }
    }
    /**
     * @return {?}
     */
    OnLeft() {
        if (this.picterno - 8 > -1) {
            this.picterno -= 8;
            this.assignImages();
        }
    }
    /**
     * @return {?}
     */
    assignImages() {
        /** @type {?} */
        var tempImg = [];
        for (let i = 0; i < 8; i++) {
            tempImg.push(this.data[i + this.picterno]);
            this.images = tempImg;
        }
    }
    /**
     * @param {?} imageno
     * @return {?}
     */
    clickImage(imageno) {
        this.assignImages();
        this.show = true;
        this.selectedImage = this.images.indexOf(this.imageno);
        this.mainImage = this.imageno;
    }
    /**
     * @return {?}
     */
    closeImage() {
        this.show = false;
    }
    /**
     * @return {?}
     */
    next() {
        if (this.selectedImage < this.images.length - 1) {
            this.selectedImage += 1;
            this.mainImage = this.images[this.selectedImage];
        }
    }
    /**
     * @return {?}
     */
    prev() {
        if (this.selectedImage > -1) {
            this.selectedImage -= 1;
            this.mainImage = this.images[this.selectedImage];
        }
    }
}
ViewImageComponent.decorators = [
    { type: Component, args: [{
                selector: 'OIV-view-image',
                template: "\n<div class=\"container\">\n  <div class=\"view\" *ngFor=\"let image of images\">\n    <img class=\"main\" [src]=\"image\" (click)=\"clickImage(this.imageno = image)\">\n  </div>\n</div>\n<div id=\"myModal\" class=\"modal\" *ngIf=\"show\">\n  <div class=\"modal-content\">\n    <span class=\"close\" (click)=\"closeImage()\">&times;</span>\n    <img [src]=\"mainImage\" class=\"main1\">\n    <div class=\"container1\">\n        <button type=\"button\" class=\"btns\" (click)=\"prev()\">prev</button>\n\n        <button type=\"button\" class=\"btns\" (click)=\"next()\" >next</button>\n    </div>\n  </div>\n</div>\n<div class=\"container2\">\n    <button type=\"button\" class=\"btns\" (click)=\"OnLeft()\" >prev</button>\n    <button type=\"button\" class=\"btns\" (click)=\"OnRight()\">next</button>\n</div>\n",
                styles: [".icons{opacity:.9;z-index:-1}.main1{-o-object-fit:contain;object-fit:contain;max-width:80%;max-height:80%;margin:auto}.main{max-width:100%;opacity:1;box-shadow:0 8px 16px rgba(black,.45);justify-content:space-between}.main:hover{max-width:100%;opacity:.2}.row{display:flex;border:5px solid #000}.container{display:-ms-grid;display:grid;-ms-grid-columns:auto auto auto auto;grid-template-columns:auto auto auto auto;-ms-grid-rows:auto auto;grid-template-rows:auto auto;grid-gap:50px;background-color:rgba(255,255,255,.1);height:98%;margin-top:10%}.container1{display:-ms-grid;display:grid;-ms-grid-columns:auto auto auto auto;grid-template-columns:auto auto auto auto;grid-gap:50px;margin-bottom:1%;position:fixed;bottom:25%;right:30%}.container2{display:-ms-grid;display:grid;-ms-grid-columns:auto auto auto auto;grid-template-columns:auto auto auto auto;grid-gap:50px;position:fixed;bottom:1%;right:30%}.container>div{background-color:rgba(255,255,255,.8);text-align:center;width:100%;font-size:30px}.mainDisplay{background-color:rgba(255,255,255,.2);padding:10px;width:98%;box-shadow:5px 10px 8px #888}.view{background-color:rgba(255,255,255,.7);box-shadow:5px 10px 8px #888}.modal{display:block;position:fixed;z-index:1;left:0;top:0;width:100%;height:100%;overflow:auto;background-color:rgba(0,0,0,.4)}.modal-content{-o-object-fit:cover;object-fit:cover;background-color:#fefefe;margin-top:5%;margin-left:10%;padding:20px;border:1px solid #888;width:80%;height:80%}.close{color:#aaa;float:right;font-size:28px;font-weight:700}.close:focus,.close:hover{color:#000;text-decoration:none;cursor:pointer}.btns{border-radius:4px;width:50px;height:50px}@media (max-width:400px){.container{display:list-item;-ms-grid-columns:100%;grid-template-columns:100%;-ms-grid-rows:100%;grid-template-rows:100%;grid-gap:10px;padding:10px}}"]
            }] }
];
/** @nocollapse */
ViewImageComponent.ctorParameters = () => [];
ViewImageComponent.propDecorators = {
    data: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class OmnipresentWebLibModule {
}
OmnipresentWebLibModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    OmnipresentWebLibComponent,
                    LoginComponent,
                    ViewImageComponent
                ],
                imports: [
                    BrowserModule,
                    FormsModule
                ],
                exports: [
                    OmnipresentWebLibComponent,
                    LoginComponent,
                    ViewImageComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { OmnipresentWebLibService, OmnipresentWebLibComponent, OmnipresentWebLibModule, LoginComponent as ɵa, ViewImageComponent as ɵb };

//# sourceMappingURL=omnipresent-web-lib.js.map